//
//
//   File: duty-cycle.c   Created 12-MAY-2007       Richard B. Johnson
//                                                  RichardBJohnson@comcast.net
//
//   The data, text, and source-code within these files are presumed to
//   be accurate and free of encumbrances. Use at your own risk.
//

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "altmath.h"
#include "MeasureLibrary.h"


#define LEN 0x1000
#define LEVEL 50.0

int main(void);


int main()
{
    double d[LEN], f;
    size_t i, duty;
    for(duty = 1; duty < 100; duty++)
    {
/*
 *  Perfect square-wave. Change duty-cycle as required.
 */
        for(i=0; i< LEN; i++)
            d[i]= ((i % 100) < duty) ? 100.0: -100.0;

/*
 *  Now add some noise I will add 10 percent noise.
 */
        for(i=0; i< LEN; i++)
            d[i] += ((((double)rand()/(double)RAND_MAX) - 0.50) * 20.0);
/*
 *  This adds 100% offset.
 */

        for(i=0; i< LEN; i++)
            d[i] -= 100.1;

        f = MeasureDutyCyclePos(d, LEN, LEVEL);
        if (fabs( f - (double)duty)  > 1.0)
            printf("Duty-cycle failed, should be %d, was %f\n", duty, f);
        InvertWaveform(d, LEN);
        f = MeasureDutyCycleNeg(d, LEN, LEVEL);
        if (fabs( f - (double)duty)  > 1.0)
            printf("Duty-cycle failed, should be %d, was %f\n", duty, f);
    }
    return 0;
}


